<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Token.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Token.hh</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Token.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_Token_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_Token_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;cstring&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">{</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="comment">//. A Token is what the Lexer splits an input stream into.</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="comment">//. It refers to a region in the underlaying buffer and it</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="comment">//. has a type.</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="comment">//.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="comment">//. - line directive:   `^&quot;#&quot;{blank}*{digit}+({blank}+.*)?\n`</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="comment">//. - pragma directive: `^&quot;#&quot;{blank}*&quot;pragma&quot;.*\n`</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="comment">//. - Constant:</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="comment">//.   </span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="comment">//.   - `{digit}+{int_suffix}*`</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="comment">//.   - `&quot;0&quot;{xletter}{hexdigit}+{int_suffix}*`</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="comment">//.   - `{digit}*\.{digit}+{float_suffix}*`</span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="comment">//.   - `{digit}+\.{float_suffix}*`</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="comment">//.   - `{digit}*\.{digit}+&quot;e&quot;(&quot;+&quot;|&quot;-&quot;)*{digit}+{float_suffix}*`</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="comment">//.   - `{digit}+\.&quot;e&quot;(&quot;+&quot;|&quot;-&quot;)*{digit}+{float_suffix}*`</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="comment">//.   - `{digit}+&quot;e&quot;(&quot;+&quot;|&quot;-&quot;)*{digit}+{float_suffix}*`</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="comment">//. </span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="comment">//. - CharConst:        `\'([^'\n]|\\[^\n])\'`</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="comment">//. - WideCharConst:    `L\'([^'\n]|\\[^\n])\'`</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="comment">//. - StringL:          `\&quot;([^&quot;\n]|\\[&quot;\n])*\&quot;`</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="comment">//. - WideStringL:      `L\&quot;([^&quot;\n]|\\[&quot;\n])*\&quot;`</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="comment">//. - Identifier:       `{letter}+({letter}|{digit})*`</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="comment">//. - AssignOp:         `*= /= %= += -= &amp;= ^= &lt;&lt;= &gt;&gt;=`</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="comment">//. - EqualOp:          `== !=`</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="comment">//. - RelOp:            `&lt;= &gt;=`</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="comment">//. - ShiftOp:          `&lt;&lt; &gt;&gt;`</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line"><span class="comment">//. - LogOrOp:          `||`</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="comment">//. - LogAndOp:         `&amp;&amp;`</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="comment">//. - IncOp:            `++ --`</span></span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="comment">//. - Scope:            `::`</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="comment">//. - Ellipsis:         `...`</span></span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="comment">//. - PmOp:             `.* -&gt;*`</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="comment">//. - ArrowOp:          `-&gt;`</span></span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="comment">//. - others:           `!%^&amp;*()-+={}|~[];:&lt;&gt;?,./`</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="comment">//. - BadToken:         `others`</span></span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="comment">//. </span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line"><span class="keyword">struct</span> <a href="../../Scopes/Synopsis/Token.html" title="struct Synopsis::Token">Token</a> </span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">{</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  <span class="keyword">typedef</span> <span class="keyword">int</span> <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Type</a>;</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">  <span class="keyword">enum</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  {</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#Identifier" title="enumerator Synopsis::Token::Identifier">Identifier</a> = 258, <span class="comment">//.&lt; The first 256 are representing character literals.</span></span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#Constant" title="enumerator Synopsis::Token::Constant">Constant</a>,</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CharConst" title="enumerator Synopsis::Token::CharConst">CharConst</a>,</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#StringL" title="enumerator Synopsis::Token::StringL">StringL</a>,</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#AssignOp" title="enumerator Synopsis::Token::AssignOp">AssignOp</a>,</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#EqualOp" title="enumerator Synopsis::Token::EqualOp">EqualOp</a>,</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#RelOp" title="enumerator Synopsis::Token::RelOp">RelOp</a>,</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ShiftOp" title="enumerator Synopsis::Token::ShiftOp">ShiftOp</a>,</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#LogOrOp" title="enumerator Synopsis::Token::LogOrOp">LogOrOp</a>,</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#LogAndOp" title="enumerator Synopsis::Token::LogAndOp">LogAndOp</a>,</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#IncOp" title="enumerator Synopsis::Token::IncOp">IncOp</a>,</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#Scope" title="enumerator Synopsis::Token::Scope">Scope</a>,</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#Ellipsis" title="enumerator Synopsis::Token::Ellipsis">Ellipsis</a>,</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#PmOp" title="enumerator Synopsis::Token::PmOp">PmOp</a>,</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ArrowOp" title="enumerator Synopsis::Token::ArrowOp">ArrowOp</a>,</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#BadToken" title="enumerator Synopsis::Token::BadToken">BadToken</a>,</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#AUTO" title="enumerator Synopsis::Token::AUTO">AUTO</a>,</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CHAR" title="enumerator Synopsis::Token::CHAR">CHAR</a>,</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CLASS" title="enumerator Synopsis::Token::CLASS">CLASS</a>,</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CONST" title="enumerator Synopsis::Token::CONST">CONST</a>,</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#DELETE" title="enumerator Synopsis::Token::DELETE">DELETE</a>,</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#DOUBLE" title="enumerator Synopsis::Token::DOUBLE">DOUBLE</a>,</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ENUM" title="enumerator Synopsis::Token::ENUM">ENUM</a>,</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#EXTERN" title="enumerator Synopsis::Token::EXTERN">EXTERN</a>,</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#FLOAT" title="enumerator Synopsis::Token::FLOAT">FLOAT</a>,</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#FRIEND" title="enumerator Synopsis::Token::FRIEND">FRIEND</a>,</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#INLINE" title="enumerator Synopsis::Token::INLINE">INLINE</a>,</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#INT" title="enumerator Synopsis::Token::INT">INT</a>,</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#LONG" title="enumerator Synopsis::Token::LONG">LONG</a>,</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#NEW" title="enumerator Synopsis::Token::NEW">NEW</a>,</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#OPERATOR" title="enumerator Synopsis::Token::OPERATOR">OPERATOR</a>,</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#PRIVATE" title="enumerator Synopsis::Token::PRIVATE">PRIVATE</a>,</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#PROTECTED" title="enumerator Synopsis::Token::PROTECTED">PROTECTED</a>,</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#PUBLIC" title="enumerator Synopsis::Token::PUBLIC">PUBLIC</a>,</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#REGISTER" title="enumerator Synopsis::Token::REGISTER">REGISTER</a>,</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#SHORT" title="enumerator Synopsis::Token::SHORT">SHORT</a>,</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#SIGNED" title="enumerator Synopsis::Token::SIGNED">SIGNED</a>,</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#STATIC" title="enumerator Synopsis::Token::STATIC">STATIC</a>,</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#STRUCT" title="enumerator Synopsis::Token::STRUCT">STRUCT</a>,</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#TYPEDEF" title="enumerator Synopsis::Token::TYPEDEF">TYPEDEF</a>,</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#TYPENAME" title="enumerator Synopsis::Token::TYPENAME">TYPENAME</a>,</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UNION" title="enumerator Synopsis::Token::UNION">UNION</a>,</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UNSIGNED" title="enumerator Synopsis::Token::UNSIGNED">UNSIGNED</a>,</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#VIRTUAL" title="enumerator Synopsis::Token::VIRTUAL">VIRTUAL</a>,</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#VOID" title="enumerator Synopsis::Token::VOID">VOID</a>,</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#VOLATILE" title="enumerator Synopsis::Token::VOLATILE">VOLATILE</a>,</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#TEMPLATE" title="enumerator Synopsis::Token::TEMPLATE">TEMPLATE</a>,</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#MUTABLE" title="enumerator Synopsis::Token::MUTABLE">MUTABLE</a>,</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#BREAK" title="enumerator Synopsis::Token::BREAK">BREAK</a>,</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CASE" title="enumerator Synopsis::Token::CASE">CASE</a>,</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CONTINUE" title="enumerator Synopsis::Token::CONTINUE">CONTINUE</a>,</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#DEFAULT" title="enumerator Synopsis::Token::DEFAULT">DEFAULT</a>,</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#DO" title="enumerator Synopsis::Token::DO">DO</a>,</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ELSE" title="enumerator Synopsis::Token::ELSE">ELSE</a>,</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#FOR" title="enumerator Synopsis::Token::FOR">FOR</a>,</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#GOTO" title="enumerator Synopsis::Token::GOTO">GOTO</a>,</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#IF" title="enumerator Synopsis::Token::IF">IF</a>,</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#OFFSETOF" title="enumerator Synopsis::Token::OFFSETOF">OFFSETOF</a>,</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#RETURN" title="enumerator Synopsis::Token::RETURN">RETURN</a>,</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#SIZEOF" title="enumerator Synopsis::Token::SIZEOF">SIZEOF</a>,</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#SWITCH" title="enumerator Synopsis::Token::SWITCH">SWITCH</a>,</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#THIS" title="enumerator Synopsis::Token::THIS">THIS</a>,</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#WHILE" title="enumerator Synopsis::Token::WHILE">WHILE</a>,</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ATTRIBUTE" title="enumerator Synopsis::Token::ATTRIBUTE">ATTRIBUTE</a>,    <span class="comment">//=g++,</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#METACLASS" title="enumerator Synopsis::Token::METACLASS">METACLASS</a>,    <span class="comment">//=opencxx</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UserKeyword" title="enumerator Synopsis::Token::UserKeyword">UserKeyword</a>,</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UserKeyword2" title="enumerator Synopsis::Token::UserKeyword2">UserKeyword2</a>,</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UserKeyword3" title="enumerator Synopsis::Token::UserKeyword3">UserKeyword3</a>,</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UserKeyword4" title="enumerator Synopsis::Token::UserKeyword4">UserKeyword4</a>,</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#BOOLEAN" title="enumerator Synopsis::Token::BOOLEAN">BOOLEAN</a>,</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#EXTENSION" title="enumerator Synopsis::Token::EXTENSION">EXTENSION</a>,    <span class="comment">//=g++,</span></span>
<a id="line126"></a><span class="lineno">126</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#TRY" title="enumerator Synopsis::Token::TRY">TRY</a>,</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#CATCH" title="enumerator Synopsis::Token::CATCH">CATCH</a>,</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#THROW" title="enumerator Synopsis::Token::THROW">THROW</a>,</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#UserKeyword5" title="enumerator Synopsis::Token::UserKeyword5">UserKeyword5</a>,</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#NAMESPACE" title="enumerator Synopsis::Token::NAMESPACE">NAMESPACE</a>,</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#USING" title="enumerator Synopsis::Token::USING">USING</a>,</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#TYPEID" title="enumerator Synopsis::Token::TYPEID">TYPEID</a>,</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#TYPEOF" title="enumerator Synopsis::Token::TYPEOF">TYPEOF</a>,</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#WideStringL" title="enumerator Synopsis::Token::WideStringL">WideStringL</a>,</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#WideCharConst" title="enumerator Synopsis::Token::WideCharConst">WideCharConst</a>,</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#WCHAR" title="enumerator Synopsis::Token::WCHAR">WCHAR</a>,</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">    </span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="comment">//=non terminals,</span></span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntDeclarator" title="enumerator Synopsis::Token::ntDeclarator">ntDeclarator</a> = 400,</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntName" title="enumerator Synopsis::Token::ntName">ntName</a>,</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntFstyleCast" title="enumerator Synopsis::Token::ntFstyleCast">ntFstyleCast</a>,</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntClassSpec" title="enumerator Synopsis::Token::ntClassSpec">ntClassSpec</a>,</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntEnumSpec" title="enumerator Synopsis::Token::ntEnumSpec">ntEnumSpec</a>,</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntDeclaration" title="enumerator Synopsis::Token::ntDeclaration">ntDeclaration</a>,</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntTypedef" title="enumerator Synopsis::Token::ntTypedef">ntTypedef</a>,</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntTemplateDecl" title="enumerator Synopsis::Token::ntTemplateDecl">ntTemplateDecl</a>,</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntMetaclassDecl" title="enumerator Synopsis::Token::ntMetaclassDecl">ntMetaclassDecl</a>,</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntParameterDecl" title="enumerator Synopsis::Token::ntParameterDecl">ntParameterDecl</a>,</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntLinkageSpec" title="enumerator Synopsis::Token::ntLinkageSpec">ntLinkageSpec</a>,</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntAccessSpec" title="enumerator Synopsis::Token::ntAccessSpec">ntAccessSpec</a>,</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntUserAccessSpec" title="enumerator Synopsis::Token::ntUserAccessSpec">ntUserAccessSpec</a>,</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntUserdefKeyword" title="enumerator Synopsis::Token::ntUserdefKeyword">ntUserdefKeyword</a>,</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntExternTemplate" title="enumerator Synopsis::Token::ntExternTemplate">ntExternTemplate</a>,</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntAccessDecl" title="enumerator Synopsis::Token::ntAccessDecl">ntAccessDecl</a>,</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntNamespaceSpec" title="enumerator Synopsis::Token::ntNamespaceSpec">ntNamespaceSpec</a>,</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntUsing" title="enumerator Synopsis::Token::ntUsing">ntUsing</a>,</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntTemplateInstantiation" title="enumerator Synopsis::Token::ntTemplateInstantiation">ntTemplateInstantiation</a>,</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntNamespaceAlias" title="enumerator Synopsis::Token::ntNamespaceAlias">ntNamespaceAlias</a>,</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntIfStatement" title="enumerator Synopsis::Token::ntIfStatement">ntIfStatement</a>,</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntSwitchStatement" title="enumerator Synopsis::Token::ntSwitchStatement">ntSwitchStatement</a>,</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntWhileStatement" title="enumerator Synopsis::Token::ntWhileStatement">ntWhileStatement</a>,</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntDoStatement" title="enumerator Synopsis::Token::ntDoStatement">ntDoStatement</a>,</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntForStatement" title="enumerator Synopsis::Token::ntForStatement">ntForStatement</a>,</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntBreakStatement" title="enumerator Synopsis::Token::ntBreakStatement">ntBreakStatement</a>,</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntContinueStatement" title="enumerator Synopsis::Token::ntContinueStatement">ntContinueStatement</a>,</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntReturnStatement" title="enumerator Synopsis::Token::ntReturnStatement">ntReturnStatement</a>,</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntGotoStatement" title="enumerator Synopsis::Token::ntGotoStatement">ntGotoStatement</a>,</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntCaseStatement" title="enumerator Synopsis::Token::ntCaseStatement">ntCaseStatement</a>,</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntDefaultStatement" title="enumerator Synopsis::Token::ntDefaultStatement">ntDefaultStatement</a>,</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntLabelStatement" title="enumerator Synopsis::Token::ntLabelStatement">ntLabelStatement</a>,</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntExprStatement" title="enumerator Synopsis::Token::ntExprStatement">ntExprStatement</a>,</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntTryStatement" title="enumerator Synopsis::Token::ntTryStatement">ntTryStatement</a>,</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntCommaExpr" title="enumerator Synopsis::Token::ntCommaExpr">ntCommaExpr</a>,</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntAssignExpr" title="enumerator Synopsis::Token::ntAssignExpr">ntAssignExpr</a>,</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntCondExpr" title="enumerator Synopsis::Token::ntCondExpr">ntCondExpr</a>,</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntInfixExpr" title="enumerator Synopsis::Token::ntInfixExpr">ntInfixExpr</a>,</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntPmExpr" title="enumerator Synopsis::Token::ntPmExpr">ntPmExpr</a>,</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntCastExpr" title="enumerator Synopsis::Token::ntCastExpr">ntCastExpr</a>,</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntUnaryExpr" title="enumerator Synopsis::Token::ntUnaryExpr">ntUnaryExpr</a>,</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntSizeofExpr" title="enumerator Synopsis::Token::ntSizeofExpr">ntSizeofExpr</a>,</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntNewExpr" title="enumerator Synopsis::Token::ntNewExpr">ntNewExpr</a>,</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntDeleteExpr" title="enumerator Synopsis::Token::ntDeleteExpr">ntDeleteExpr</a>,</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntArrayExpr" title="enumerator Synopsis::Token::ntArrayExpr">ntArrayExpr</a>,</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntFuncallExpr" title="enumerator Synopsis::Token::ntFuncallExpr">ntFuncallExpr</a>,</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntPostfixExpr" title="enumerator Synopsis::Token::ntPostfixExpr">ntPostfixExpr</a>,</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntUserStatementExpr" title="enumerator Synopsis::Token::ntUserStatementExpr">ntUserStatementExpr</a>,</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntDotMemberExpr" title="enumerator Synopsis::Token::ntDotMemberExpr">ntDotMemberExpr</a>,</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntArrowMemberExpr" title="enumerator Synopsis::Token::ntArrowMemberExpr">ntArrowMemberExpr</a>,</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntParenExpr" title="enumerator Synopsis::Token::ntParenExpr">ntParenExpr</a>,</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntStaticUserStatementExpr" title="enumerator Synopsis::Token::ntStaticUserStatementExpr">ntStaticUserStatementExpr</a>,</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntThrowExpr" title="enumerator Synopsis::Token::ntThrowExpr">ntThrowExpr</a>,</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntTypeidExpr" title="enumerator Synopsis::Token::ntTypeidExpr">ntTypeidExpr</a>,</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ntTypeofExpr" title="enumerator Synopsis::Token::ntTypeofExpr">ntTypeofExpr</a>,</span>
<a id="line196"></a><span class="lineno">196</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#Ignore" title="enumerator Synopsis::Token::Ignore">Ignore</a>  = 500,</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#ASM" title="enumerator Synopsis::Token::ASM">ASM</a>,</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#DECLSPEC" title="enumerator Synopsis::Token::DECLSPEC">DECLSPEC</a>,</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#PRAGMA" title="enumerator Synopsis::Token::PRAGMA">PRAGMA</a>,</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#INT64" title="enumerator Synopsis::Token::INT64">INT64</a>,</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">    <a href="../../Scopes/Synopsis/Token.html#Comment" title="enumerator Synopsis::Token::Comment">Comment</a> <span class="comment">// This could eventually be used to report all comments.</span></span>
<a id="line203"></a><span class="lineno">203</span><span class="line">  };</span>
<a id="line204"></a><span class="lineno">204</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Token_l_r" title="member function Synopsis::Token::Token()">Token</a>() : ptr(0), length(0), type(BadToken) {}</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Token_lconst.char_S_csize_t_cType_r" title="member function Synopsis::Token::Token(const char*,size_t,Type)">Token</a>(<span class="keyword">const</span> <span class="keyword">char</span> *s, <a href="" title="typedef size_t">size_t</a> l, <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Type</a> t) : ptr(s), length(l), type(t) {}</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">  <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Token.html#operator_e_e_lchar_rconst" title="member function Synopsis::Token::operator==(char)const">operator ==</a> (<span class="keyword">char</span> c) const { <span class="keyword">return</span> *<a href="../../Scopes/Synopsis/Token.html#ptr" title="data member Synopsis::Token::ptr">ptr</a> == <a href="" title="parameter c">c</a> &amp;&amp; <a href="../../Scopes/Synopsis/Token.html#length" title="data member Synopsis::Token::length">length</a> == <span class="literal">1</span>;}</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">  <span class="keyword">const</span> <span class="keyword">char</span> *<a href="../../Scopes/Synopsis/Token.html#ptr" title="data member Synopsis::Token::ptr">ptr</a>;</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">  <a href="" title="typedef size_t">size_t</a>      <a href="../../Scopes/Synopsis/Token.html#length" title="data member Synopsis::Token::length">length</a>;</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">  <a href="../../Scopes/Synopsis/Token.html#Type" title="typedef Synopsis::Token::Type">Type</a>        <a href="../../Scopes/Synopsis/Token.html#type" title="data member Synopsis::Token::type">type</a>;</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">};</span>
<a id="line212"></a><span class="lineno">212</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">}</span>
<a id="line214"></a><span class="lineno">214</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:03 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
